## apt-cacher-ng 0.7.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

PROJECT(ACNG CXX C)

INCLUDE (CheckIncludeFiles) 
#INCLUDE (CheckLibraryExists)

INCLUDE_DIRECTORIES(. ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "include")

# minimum prqs
list(APPEND AcngLdList pthread z bz2)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckCXXSourceRuns)
INCLUDE(CheckIncludeFiles)

# I don't need -rdynamic, thanks!
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

# common required flags
SET(FLAGS_MIN " -pthread -Wall -D_FILE_OFFSET_BITS=64 ")

IF(CMAKE_SYSTEM MATCHES "Darwin")
   SET(FLAGS_MIN " ${FLAGS_MIN} -D_DARWIN_C_SOURCE ")
ENDIF(CMAKE_SYSTEM MATCHES "Darwin")
CHECK_INCLUDE_FILES ("sys/param.h;sys/mount.h" HAVE_SYS_MOUNT_H)
CHECK_INCLUDE_FILES ("sys/vfs.h" HAVE_SYS_VFS_H)

#SET(CMAKE_REQUIRED_FLAGS " -std=gnu++0x ")
#CHECK_CXX_SOURCE_COMPILES("int main() {return 0;}" NEEDS_GNU_0x)
#if(NEEDS_GNU_0x)
#   SET(FLAGS_MIN " ${FLAGS_MIN} -std=gnu++0x ")
#endif(NEEDS_GNU_0x)


#INCLUDE(FindZLIB) # broken, hangs for 10 seconds
# header check should be enough, gzip should be everywhere nowadays
#CHECK_INCLUDE_FILES("gzip.h" HAVE_ZLIB)
FIND_PATH(HAVE_ZLIB zlib.h )
if(NOT HAVE_ZLIB)
   message(FATAL_ERROR "apt-cacher-ng requires gzip library and development files ${HAVE_ZLIB}")
endif(NOT HAVE_ZLIB)

INCLUDE(FindBZip2)
if (BZIP2_FOUND)
   SET(HAVE_LIBBZ2 1)
   MARK_AS_ADVANCED(HAVE_LIBBZ2)
else (BZIP2_FOUND)
   message(FATAL_ERROR "apt-cacher-ng requires bzip2 library and development files")
endif (BZIP2_FOUND)

INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})

SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} -Wl,--as-needed")
SET(TESTSRC "int main() {return 0;}")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WL_AS_NEEDED)

# this flags are set to common base for the rest of the tests
SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} ")


SET(CMAKE_REQUIRED_LIBRARIES lzma)
SET(TESTSRC "
#include <lzma.h>
lzma_stream t; int main(){ return lzma_stream_decoder (&t, 32000000, LZMA_TELL_UNSUPPORTED_CHECK | LZMA_CONCATENATED); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LZMA)
IF(HAVE_LZMA)
   list(APPEND AcngLdList lzma)
ELSE(HAVE_LZMA)
   MESSAGE("XZ (liblzma) not found or not working, disabling support")
   SET(HAVE_LZMA )
ENDIF(HAVE_LZMA)
SET(CMAKE_REQUIRED_LIBRARIES "")

SET(CMAKE_REQUIRED_LIBRARIES wrap)
SET(TESTSRC "
#include <tcpd.h>
int main() { request_info req; request_init(&req, RQ_FILE, 0, 0); fromhost(&req); return !hosts_access(&req); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LIBWRAP)
IF(HAVE_LIBWRAP)
   list(APPEND AcngLdList wrap)
ELSE(HAVE_LIBWRAP)
   MESSAGE("libwrap development files not usable, disabling support")
   SET(HAVE_LIBWRAP)
ENDIF(HAVE_LIBWRAP)
SET(CMAKE_REQUIRED_LIBRARIES "")


SET(TESTSRC "
#include <wordexp.h>
int main(int argc, char **argv) { wordexp_t p; return wordexp(*argv, &p, 0); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WORDEXP)

SET(TESTSRC "
#include <glob.h>
int main(int argc, char **argv) { glob_t p; return glob(*argv, 0, 0, &p); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_GLOB)

SET(TESTSRC "
#define _XOPEN_SOURCE 600
#include <fcntl.h>
int testme(int fd, off_t offset, off_t len, int) { return posix_fadvise(fd, offset, len, POSIX_FADV_SEQUENTIAL); }; int main(int,char**){return testme(0,0,0,0);}
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FADVISE)
# Solaris fallback
IF(NOT HAVE_FADVISE)
SET(TESTSRC "
#include <fcntl.h>
int testme(int fd, off_t offset, off_t len, int) { return posix_fadvise(fd, offset, len, POSIX_FADV_SEQUENTIAL); }; int main(int,char**){return testme(0,0,0,0);}
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FADVISE)
ENDIF(NOT HAVE_FADVISE)

SET(TESTSRC "
#include <sys/mman.h>
int testme(void *addr, size_t length, int advice) { return posix_madvise(addr, length, advice); } int main(int,char**){return testme(0,0,0);}
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_MADVISE)

SET(TESTSRC "
#define _GNU_SOURCE
#include <linux/falloc.h>
#include <fcntl.h>
int main() { int fd=1; return fallocate(fd, FALLOC_FL_KEEP_SIZE, 1, 2); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_FALLOCATE)

SET(TESTSRC "
#include <sys/sendfile.h>
int main(int argc, char **argv) { off_t yes(3); return (int) sendfile(1, 2, &yes, 4); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_SENDFILE)

SET(TESTSRC "
#include <unistd.h>
int main() { return pread(0, NULL, 0, 0); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_PREAD)

SET(TESTSRC "
#include <unistd.h>
int main() { return daemon(0, 0); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DAEMON)

SET(TESTSRC "
#define _GNU_SOURCE
#include <fcntl.h>
int main() { loff_t sin(12), sout(34); return splice(0, &sin, 1, &sout, 12, SPLICE_F_MORE); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LINUX_SPLICE)

FIND_LIBRARY(HAVE_SOCKETLIB socket) # separate socket lib looks like Solaris-like environment
if(HAVE_SOCKETLIB)
   link_libraries(socket nsl)
endif(HAVE_SOCKETLIB)

#CHECK_INCLUDE_FILES(tcpd.h HAVE_LIBWRAP)
#if(HAVE_LIBWRAP)
## also check its library
#  FIND_LIBRARY(tempvar wrapi)
#  if(NOT tempvar)
#     SET(HAVE_LIBWRAP "")
#  endif(NOT tempvar)
#endif(HAVE_LIBWRAP)

INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(int SIZE_INT)
CHECK_TYPE_SIZE(long SIZE_LONG)

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)

SET(TESTSRC "
#include <memory>
int main() { return NULL != std::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_MEMORY_SPTR)

SET(TESTSRC "
#include <tr1/memory>
int main() { return NULL != std::tr1::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_TR1_MEMORY)

set(CMAKE_REQUIRED_INCLUDES . ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR})

SET(TESTSRC "
#include <boost/smart_ptr.hpp>
int main() { return NULL != boost::shared_ptr<int>(new int(1)); }
")
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_BOOST_SMARTPTR)
set(CMAKE_REQUIRED_INCLUDES "")

if(NOT HAVE_BOOST_SMARTPTR)
   if(NOT HAVE_TR1_MEMORY)
      if(NOT HAVE_MEMORY_SPTR)
         message(FATAL_ERROR "Could not find a working smart pointer implementation. Please read documentation and include boost headers.")
      endif(NOT HAVE_MEMORY_SPTR)
   endif(NOT HAVE_TR1_MEMORY)
endif(NOT HAVE_BOOST_SMARTPTR)

SET(TESTSRC "
#include <dlfcn.h>
int main(int argc, char **argv)
{
  return dlsym(dlopen(*argv, RTLD_LAZY), *argv) ?0:1;
}
")
SET(CMAKE_REQUIRED_LIBRARIES dl)
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DLOPEN)
SET(CMAKE_REQUIRED_LIBRARIES "")

SET(TESTSRC "
#include <pthread.h>
#include <errno.h>
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t mx = PTHREAD_MUTEX_INITIALIZER;

void* stop_it(void *)
{
   pthread_mutex_lock(&mx);
   pthread_cond_broadcast(&cond);
   pthread_mutex_unlock(&mx);
   return NULL;
}

int main(void)
{
   // no problem with small type
   const struct timespec timeout = {9223372036854775807L, 12345};
   if(sizeof(timeout.tv_sec) < 8)
      return 0;
   for(int i=0;i<30;++i)
   {
      pthread_mutex_lock(&mx);
      pthread_t thr;
      if(pthread_create(&thr,0,stop_it,0))
         return -1;
      switch(pthread_cond_timedwait(&cond, &mx, &timeout))
      {
         case EINTR:
            continue; // loaded system, or killed by user?
         case 0:
            return 0; // correctly awaken = good
         default:
            return 1; // buggy implementation
      }
      pthread_mutex_unlock(&mx);
      pthread_join(thr, 0);
   }
   return -2;
}
")
SET(CMAKE_REQUIRED_LIBRARIES pthread)
CHECK_CXX_SOURCE_RUNS("${TESTSRC}" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
SET(CMAKE_REQUIRED_LIBRARIES "")


FILE(GLOB SRCS "${CMAKE_SOURCE_DIR}/source/*.cc")
ADD_EXECUTABLE(apt-cacher-ng ${SRCS})
list(REMOVE_DUPLICATES AcngLdList)
TARGET_LINK_LIBRARIES(apt-cacher-ng ${AcngLdList})

SET_TARGET_PROPERTIES(apt-cacher-ng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})


ADD_EXECUTABLE(in.acng client/client.cc)
SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})

IF(HAVE_WL_AS_NEEDED)
SET_TARGET_PROPERTIES(in.acng apt-cacher-ng PROPERTIES LINK_FLAGS  -Wl,--as-needed)
# funny hack, link with gcc and avoid libstdc++/libm (since no STL parts used
# there). However, it needs to be investigated - the alternative linking makes
# the binary 40kb larger, might include higher relocation costs and bigger
# chunks of unique memory while libstdc++ needs to be loaded anyway for the
# server process.
#TARGET_LINK_LIBRARIES(in.acng supc++)
#SET_TARGET_PROPERTIES(in.acng PROPERTIES LINKER_LANGUAGE C)
ENDIF(HAVE_WL_AS_NEEDED)


############################################
## Attempt to build acngfs where possible ##
############################################

include(FindPkgConfig)
pkg_check_modules(fuse fuse)

set(acngfs_cflags "${FLAGS_MIN} -DMINIBUILD")
# what a mess... convert sepator back to space
foreach(arg ${fuse_CFLAGS})
   set(fuse_cflags "${fuse_cflags} ${arg}")
   set(acngfs_cflags "${acngfs_cflags} ${arg}")
endforeach(arg ${fuse_CFLAGS})

# double-check and make sure it compiles
SET(TESTSRC "
#define _FILE_OFFSET_BITS 64
#define FUSE_USE_VERSION 25
#include <fuse.h>
int main() { return 0; }
")
SET(CMAKE_REQUIRED_FLAGS ${fuse_cflags})
CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_25)

if(fuse_FOUND AND HAVE_FUSE_25)
   if(ADDDEBUGSRC)
      ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/acfg.cc source/acfg_defaults.cc source/tcpconnect.cc source/dlcon.cc source/fileitem.cc source/aclogger.cc source/meta.cc)
   else(ADDDEBUGSRC)
      ADD_EXECUTABLE(acngfs fs/httpfs.cc source/lockable.cc source/header.cc source/caddrinfo.cc source/acbuf.cc source/acfg.cc source/acfg_defaults.cc source/tcpconnect.cc source/dlcon.cc source/fileitem.cc source/meta.cc)
   endif(ADDDEBUGSRC)

   # message("uhm: ${acngfs_cflags} -- ${fuse_LDFLAGS} -- ${HAVE_DLOPEN}")
   SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )
   if(HAVE_DLOPEN)
      TARGET_LINK_LIBRARIES(acngfs dl pthread)
   else(HAVE_DLOPEN)
      TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS})
   endif(HAVE_DLOPEN)

   IF(HAVE_WL_AS_NEEDED)
      SET_TARGET_PROPERTIES(acngfs PROPERTIES LINK_FLAGS  -Wl,--as-needed)
   ENDIF(HAVE_WL_AS_NEEDED)


else(fuse_FOUND AND HAVE_FUSE_25)
   message("FUSE not found or incompatible, not building acngfs")
endif(fuse_FOUND AND HAVE_FUSE_25)


######################################
# all checks done, save configuration    #
######################################

CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")

=== debian/changelog ===
apt-cacher-ng (0.7.18-1) unstable; urgency=medium

  * New upstream release
    + includes tmpfile for proper startup with systemd (closes: #720215)

 -- Eduard Bloch <blade@debian.org>  Tue, 20 Aug 2013 00:45:51 +0200

apt-cacher-ng (0.7.17-1) unstable; urgency=medium

  * New upstream version
  * Various meta changes, removed binutils-gold conflict (closes: #719428)
  * systemd service config integration (closes: #716810)

 -- Eduard Bloch <blade@debian.org>  Sun, 18 Aug 2013 23:09:40 +0200

apt-cacher-ng (0.7.16-1) unstable; urgency=medium

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Wed, 31 Jul 2013 23:36:07 +0200

apt-cacher-ng (0.7.15-1) unstable; urgency=medium

  * New upstream version
    + handles timeouts from stale connections correctly (closes: #717832)
    + fixes varios regressions from 0.7.14

 -- Eduard Bloch <blade@debian.org>  Sun, 28 Jul 2013 21:05:54 +0200

apt-cacher-ng (0.7.14-1) unstable; urgency=low

  * New upstream version
    + prevents background looping (closes: #703296)
    + stop spamming apt-cacher.err when verbosity is not set to debug mode
      (closes: #714146)
  * Remove system user account with bare passwd tools where adduser package
    has been removed before purging apt-cacher-ng (LP: #1185547)

 -- Eduard Bloch <blade@debian.org>  Sat, 20 Jul 2013 10:55:07 +0200

apt-cacher-ng (0.7.13-1) unstable; urgency=medium

  * New upstream release
  * using Ubuntu config optimization added in the last version only where curl
    or wget are available and added curl or wget to Suggests (closes: #698466)
  * working around adduser failure on certain systems (closes: #706382)
  * added basic support for avahi publishing contributed by Lissandro,
    thanks! (closes: #704790)

 -- Eduard Bloch <blade@debian.org>  Tue, 21 May 2013 20:23:51 +0200

apt-cacher-ng (0.7.12-1) experimental; urgency=low

  * New upstream release
    + adds filename patterns for mirrors.txt (LP: #1020995)
    + adds options to configure pipeline behavior (LP: #1097952)
  * Using Ubuntu's mirrors.txt service to get a better fallback backend list
  * minor postinst fixes to deal with trailing spaces in modification checks

 -- Eduard Bloch <blade@debian.org>  Sat, 12 Jan 2013 20:15:14 +0100

=== debian/control ===
Source: apt-cacher-ng
Section: net
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 7.2.3), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev, lsb-base (>> 3.0-6), dh-systemd
Standards-Version: 3.9.4
Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/

Package: apt-cacher-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Pre-Depends: dpkg (>= 1.15.6)
Recommends: perl (>> 5.8), ed, avahi-daemon
Conflicts: logrotate (<< 3.8.0)
Suggests: doc-base, libfuse2 (>= 2.5), curl | wget
Description: caching proxy server for software repositories
 Apt-Cacher NG is a caching proxy for downloading packages from Debian-style
 software repositories (or possibly from other types).
 .
 The main principle is that a central machine hosts the proxy for a local
 network, and clients configure their APT setup to download through it.
 Apt-Cacher NG keeps a copy of all useful data that passes through it, and when
 a similar request is made, the cached copy of the data is delivered without
 being re-downloaded.
 .
 Apt-Cacher NG has been designed from scratch as a replacement for
 apt-cacher, but with a focus on maximizing throughput with low system
 resource requirements. It can also be used as replacement for apt-proxy and
 approx with no need to modify clients' sources.list files.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
SHELL=/bin/bash
CDIR=$(CURDIR)/debian/apt-cacher-ng/etc/apt-cacher-ng/
TGT="$(CURDIR)/debian/apt-cacher-ng"

CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS) -Wall
export CFLAGS
CXXFLAGS=$(CFLAGS)
export CXXFLAGS
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) 
export LDFLAGS


PARJOBS=-j2
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PARJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif


configure: configure-stamp
configure-stamp:
	dh_testdir
	$(MAKE) config
	touch configure-stamp

build: build-arch build-indep

build-indep:

build-arch: configure-stamp 
	dh_testdir
	$(MAKE) $(PARJOBS)
	# may fail if halibut is not installed, doesn't matter
	#-$(MAKE) doc
	@-test -d ../unstripped && cp build/apt-cacher-ng ../unstripped/apt-cacher-ng.$$(dpkg-parsechangelog |grep ^Version: | cut -f2 -d' ') || true
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	$(MAKE) $(MAKEFLAGS) distclean || true
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	install build/apt-cacher-ng $(TGT)/usr/sbin/apt-cacher-ng
	install build/in.acng expire-caller.pl urlencode-fixer.pl distkill.pl $(TGT)/usr/lib/apt-cacher-ng/
	# optional
	-install build/acngfs $(TGT)/usr/lib/apt-cacher-ng/
	cp -a conf/{*mirror*,*.html,*.css} $(TGT)/usr/lib/apt-cacher-ng
	cp -a conf/*.conf $(CDIR)
	cp contrib/apt-cacher-ng.service $(TGT)/etc/avahi/services/apt-cacher-ng.service 
	# that's systemd service file, not avahi's
	cp systemd/apt-cacher-ng.service debian
	cp systemd/apt-cacher-ng.conf debian/apt-cacher-ng.tmpfile
	> $(CDIR)/backends_debian
	> $(CDIR)/backends_debvol
	> $(CDIR)/backends_ubuntu
#	cd $(CDIR) && cp -s ../../usr/lib/apt-cacher-ng/{*mirror*,*.html,*.css} . 
	ln -sf ../../var/lib/apt-cacher-ng/backends_debian.default $(CDIR)/backends_debian.default
	ln -sf ../../var/lib/apt-cacher-ng/backends_ubuntu.default $(CDIR)/backends_ubuntu.default

# Build architecture-independent files here.
binary-indep: build-indep install

# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples conf/*.conf conf/debrep.hooks doc/000apt-cacher-ng-proxy contrib/*.conf
	dh_installdebconf	
	dh_installlogrotate
	dh_systemd_enable
	dh_installinit -- defaults 18
	dh_systemd_start
	dh_installcron
	dh_installman doc/man/*.8
	dh_bugfiles
	dh_link
	dh_strip
	dh_compress -X.pdf
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb -- -Zxz

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## apt-cacher-ng 0.7.25

=== debian/changelog ===
apt-cacher-ng (0.7.25-1~bpo70+1) wheezy-backports; urgency=low

  * Updated wheezy backport

 -- Eduard Bloch <blade@debian.org>  Mon, 03 Feb 2014 22:11:29 +0100

apt-cacher-ng (0.7.25-1) unstable; urgency=medium

  * New upstream version with various bugfixes

 -- Eduard Bloch <blade@debian.org>  Sun, 05 Jan 2014 12:29:56 +0100

apt-cacher-ng (0.7.24-2) unstable; urgency=medium

  * Postinst now behaves more sensibly on configuration read errors during
    CacheDir plausibility check, also setting more defensive permissions
    to some protected (generated) config files at least for future
    installations (closes: #733141)

 -- Eduard Bloch <blade@debian.org>  Mon, 30 Dec 2013 01:25:40 +0100

apt-cacher-ng (0.7.24-1) unstable; urgency=medium

  * New upstream version
  * Review of maintainer scripts, now responsive to modification of
    CacheDir in existing configuration file(s)
  * Defensive behavior of Debconf integration (closes: #732606) and including
    NEWS.Debian to explain the extended config handling 
  * added libssl-dev to build dependencies (now really closes: #729508)
  * fixing build failure on architectures where ancgfs is not built (i.e. Hurd)
  * Debconf description improvement in better German translation

 -- Eduard Bloch <blade@debian.org>  Thu, 19 Dec 2013 21:10:19 +0100

apt-cacher-ng (0.7.23-1) unstable; urgency=medium

  * New upstream version
    + fixes reading of certain .xz files (closes: #729941, #731804)
    + HTTPS support (closes: #729508)
  * more debconf controlled settings injected through a separate config
    file, partially based on the patch from 
    Geert Stappers <stappers@stappers.nl> (closes: #726656)
  * policy version bump, and no longer recommending perl, there are enough
    functionality replacements implemented to work with just perl-base
  * changed maximum version counts in lograte configuration to lower numbers

 -- Eduard Bloch <blade@debian.org>  Tue, 17 Dec 2013 21:18:15 +0100

apt-cacher-ng (0.7.22-1) unstable; urgency=low

  * New upstream version
    + fixes backend list parser (closes: #731770, LP:#1259191)

 -- Eduard Bloch <blade@debian.org>  Mon, 09 Dec 2013 21:32:14 +0100

apt-cacher-ng (0.7.21-1) unstable; urgency=low

  * New upstream version
    + adds ftp.debian.com alias to the DB (closes: #730365, LP: #1254441)
    + adds consistent credentials handling for URLs specs (closes: #729505)
    + workaround for non-free/.../Packages.xz file reading in expiration
      activities (bug 729941)

 -- Eduard Bloch <blade@debian.org>  Mon, 09 Dec 2013 00:20:09 +0100

apt-cacher-ng (0.7.20-2) unstable; urgency=low

  * Create the user before doing dpkg-statoverride (closes: #730360)

 -- Eduard Bloch <blade@debian.org>  Mon, 25 Nov 2013 22:03:52 +0100

apt-cacher-ng (0.7.20-1) unstable; urgency=low

  * New upstream version
    + Attempts to recreate its cache directory (closes: #729939)
  * make sure not to fail on postrm (purge) when the config directory
    still contains unexpected files (closes: #728236)
  * now really removing config files maintained only by maintainer scripts from
    dpkg's conffile tracking (closes: #728263)

 -- Eduard Bloch <blade@debian.org>  Sat, 23 Nov 2013 20:54:35 +0100

apt-cacher-ng (0.7.19-1) unstable; urgency=low

  [ Eduard Bloch ]
  * New upstream version
    + prints errno message from a failed daemon() call (closes: #726925)
    + suppresses output from the red utility leaked to stderr (closes: #722600)
  * Attempting to use a http proxy from apt settings for the mirror lookup in
    postinst (closes: #720954)
  * no longer delivering empty conffiles (backends_*, closes: #720296)
  [ Julian Andres Klode ]
  * Included IPv6 in the avahi config (closes: #722907)
  [ Lukas Anzinger <l.anzinger@gmail.com> ]
  * Converted apt-cacher-ng to debhelper 9 (closes: #722712)

 -- Eduard Bloch <blade@debian.org>  Mon, 28 Oct 2013 22:20:09 +0100

apt-cacher-ng (0.7.18-1~bpo70+1) wheezy-backports; urgency=low

  * Wheezy backport
  * Disabled native systemd support due to limited tool availability

 -- Eduard Bloch <blade@debian.org>  Wed, 18 Sep 2013 22:14:34 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: net
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 7.2.3), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev, lsb-base (>> 3.0-6), dh-systemd
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9), cmake (>= 2.6.2), libbz2-dev, zlib1g-dev, liblzma-dev, libfuse-dev [!hurd-i386], pkg-config, libwrap0-dev, lsb-base (>> 3.0-6), po-debconf, libssl-dev
+Standards-Version: 3.9.5
 Homepage: http://www.unix-ag.uni-kl.de/~bloch/acng/
 
 Package: apt-cacher-ng
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Pre-Depends: dpkg (>= 1.15.6)
-Recommends: perl (>> 5.8), ed, avahi-daemon
+Recommends: ed, avahi-daemon
 Conflicts: logrotate (<< 3.8.0)
 Suggests: doc-base, libfuse2 (>= 2.5), curl | wget
 Description: caching proxy server for software repositories

## apt-cacher-ng 0.7.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -74,6 +74,19 @@
    MESSAGE("XZ (liblzma) not found or not working, disabling support")
    SET(HAVE_LZMA )
 ENDIF(HAVE_LZMA)
+SET(CMAKE_REQUIRED_LIBRARIES "")
+
+SET(SSL_LIB_LIST ssl crypto)
+SET(CMAKE_REQUIRED_LIBRARIES "${SSL_LIB_LIST}")
+SET(TESTSRC "#include \"${CMAKE_SOURCE_DIR}/include/testssl.h\"")
+CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_SSL)
+IF(HAVE_SSL)
+   list(APPEND AcngLdList "${SSL_LIB_LIST}")
+ELSE(HAVE_SSL)
+   MESSAGE("OpenSSL not found or not working, disabling support")
+   SET(HAVE_SSL )
+   SET(SSL_LIB_LIST )
+ENDIF(HAVE_SSL)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
 SET(CMAKE_REQUIRED_LIBRARIES wrap)
@@ -207,60 +220,13 @@
    endif(NOT HAVE_TR1_MEMORY)
 endif(NOT HAVE_BOOST_SMARTPTR)
 
-SET(TESTSRC "
-#include <dlfcn.h>
-int main(int argc, char **argv)
-{
-  return dlsym(dlopen(*argv, RTLD_LAZY), *argv) ?0:1;
-}
-")
 SET(CMAKE_REQUIRED_LIBRARIES dl)
-CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_DLOPEN)
-SET(CMAKE_REQUIRED_LIBRARIES "")
-
-SET(TESTSRC "
-#include <pthread.h>
-#include <errno.h>
-pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
-pthread_mutex_t mx = PTHREAD_MUTEX_INITIALIZER;
-
-void* stop_it(void *)
-{
-   pthread_mutex_lock(&mx);
-   pthread_cond_broadcast(&cond);
-   pthread_mutex_unlock(&mx);
-   return NULL;
-}
-
-int main(void)
-{
-   // no problem with small type
-   const struct timespec timeout = {9223372036854775807L, 12345};
-   if(sizeof(timeout.tv_sec) < 8)
-      return 0;
-   for(int i=0;i<30;++i)
-   {
-      pthread_mutex_lock(&mx);
-      pthread_t thr;
-      if(pthread_create(&thr,0,stop_it,0))
-         return -1;
-      switch(pthread_cond_timedwait(&cond, &mx, &timeout))
-      {
-         case EINTR:
-            continue; // loaded system, or killed by user?
-         case 0:
-            return 0; // correctly awaken = good
-         default:
-            return 1; // buggy implementation
-      }
-      pthread_mutex_unlock(&mx);
-      pthread_join(thr, 0);
-   }
-   return -2;
-}
-")
+CHECK_CXX_SOURCE_COMPILES("#include \"${CMAKE_SOURCE_DIR}/include/testdlopen.h\"" HAVE_DLOPEN)
+SET(CMAKE_REQUIRED_LIBRARIES "")
+
+# maybe enable workaround for platforms with a weird implementation
 SET(CMAKE_REQUIRED_LIBRARIES pthread)
-CHECK_CXX_SOURCE_RUNS("${TESTSRC}" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
+CHECK_CXX_SOURCE_RUNS("#include \"${CMAKE_SOURCE_DIR}/include/testpthread.h\"" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
 
@@ -321,9 +287,9 @@
    # message("uhm: ${acngfs_cflags} -- ${fuse_LDFLAGS} -- ${HAVE_DLOPEN}")
    SET_TARGET_PROPERTIES(acngfs PROPERTIES COMPILE_FLAGS "${acngfs_cflags}" )
    if(HAVE_DLOPEN)
-      TARGET_LINK_LIBRARIES(acngfs dl pthread)
+      TARGET_LINK_LIBRARIES(acngfs dl pthread ${SSL_LIB_LIST})
    else(HAVE_DLOPEN)
-      TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS})
+      TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS} ${SSL_LIB_LIST})
    endif(HAVE_DLOPEN)
 
    IF(HAVE_WL_AS_NEEDED)
@@ -336,8 +302,8 @@
 endif(fuse_FOUND AND HAVE_FUSE_25)
 
 
-######################################
-# all checks done, save configuration    #
-######################################
+#######################################
+# all checks done, save configuration #
+#######################################
 
 CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")

=== debian/changelog ===
apt-cacher-ng (0.7.26-1ubuntu0.1) trusty; urgency=medium

  [ Rolf Leggewie ]
  * backport appstream support from upstream (LP: #1547431).

  [Stefan Bader]
  * backport support for by-hash index files (LP: #1568754).

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 11 Apr 2016 15:28:48 +0200

apt-cacher-ng (0.7.26-1) unstable; urgency=medium

  * New upstream version
    + fixes the link action for quick forced file expiration (closes: #736684)
    + fixes incorrect percent escaping in some cases (thanks! closes: #737268)
    + adds gentoo_mirrors.default, config should work now (closes: #736579)
  * reconsidered purging strategy, only remove files in the default location
    because when the user changed the location manually to an external folder
    then the data there better should not be destroyed (also closes: #736684)
  * added http.debian.net as another special host like cdn.d.n (closes: #741272)
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #733087
  * [Debconf translation updates]
  * Russian (Yuri Kozlov).  Closes: #736847
  * Danish (Joe Hansen).  Closes: #736876
  * Brazilian Portuguese (Adriano Rafael Gomes).  Closes: #737468
  * French (Jean-Baka Domelevo Entfellner).  Closes: #737714
  * Basque (Joseba Goitia Gandiaga).  Closes: #738021
  * Czech (Miroslav Kure).  Closes: #738355
  * Italian (Beatrice Torracca).  Closes: #738574
  * Japanese (Hideki Yamane (Debian-JP)).  Closes: #738724
  * Polish (Michał Kułach).  Closes: #738746
  * Portuguese (Pedro Ribeiro).  Closes: #738790
  * Spanish (Matías A. Bellone).  Closes: #739799
  * German (Eduard Bloch)

 -- Eduard Bloch <blade@debian.org>  Sat, 22 Mar 2014 14:20:56 +0100

=== debian/rules ===
#!/usr/bin/make -f

TGT=$(CURDIR)/debian/apt-cacher-ng
CDIR=$(TGT)/etc/apt-cacher-ng

%:
	dh $@ --parallel --with systemd

override_dh_install:
	dh_install $(test -e build/acngfs || echo -Xacngfs)
	cp systemd/apt-cacher-ng.service debian
	cp systemd/apt-cacher-ng.conf debian/apt-cacher-ng.tmpfile
	install -m 755 expire-caller.pl $(TGT)/usr/lib/apt-cacher-ng

override_dh_installinit:
	dh_installinit -- defaults 18

override_dh_compress:
	dh_compress -X.pdf

override_dh_clean:
	dh_clean
	rm -f debian/apt-cacher-ng.service debian/apt-cacher-ng.tmpfile
	debconf-updatepo

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

## apt-cacher-ng 0.7.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,59 +9,108 @@
 INCLUDE_DIRECTORIES(. ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR} "include")
 
 # minimum prqs
-list(APPEND AcngLdList pthread z bz2)
+list(APPEND AcngLdList pthread)
 
 INCLUDE(CheckIncludeFiles)
 INCLUDE(CheckCXXSourceCompiles)
 INCLUDE(CheckCXXSourceRuns)
 INCLUDE(CheckIncludeFiles)
 
-# I don't need -rdynamic, thanks!
-SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
-SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
-
-# common required flags
-SET(FLAGS_MIN " -pthread -Wall -D_FILE_OFFSET_BITS=64 ")
+# common required flags to be used later for CMAKE_REQUIRED_FLAGS and the build,
+# CXXFLAGS (via initial CMAKE_CXX_FLAGS) can override them
+SET(FLAGS_MIN " -pthread -g -O2 -Wall -Wextra -Wno-unused-parameter -D_FILE_OFFSET_BITS=64 ${CMAKE_CXX_FLAGS}")
+# same for linker flags, imported from LDFLAGS environment var
+SET(LDFLAGS_MIN "${CMAKE_EXE_LINKER_FLAGS}")
+
+message("Initial CXX flags: ${FLAGS_MIN}")
+message("Initial linker flags: ${LDFLAGS_MIN}")
 
 IF(CMAKE_SYSTEM MATCHES "Darwin")
    SET(FLAGS_MIN " ${FLAGS_MIN} -D_DARWIN_C_SOURCE ")
 ENDIF(CMAKE_SYSTEM MATCHES "Darwin")
+
+SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}")
+
+# Various feature checks
 CHECK_INCLUDE_FILES ("sys/param.h;sys/mount.h" HAVE_SYS_MOUNT_H)
 CHECK_INCLUDE_FILES ("sys/vfs.h" HAVE_SYS_VFS_H)
 
-#SET(CMAKE_REQUIRED_FLAGS " -std=gnu++0x ")
-#CHECK_CXX_SOURCE_COMPILES("int main() {return 0;}" NEEDS_GNU_0x)
-#if(NEEDS_GNU_0x)
-#   SET(FLAGS_MIN " ${FLAGS_MIN} -std=gnu++0x ")
-#endif(NEEDS_GNU_0x)
-
+if(USE_CXX11)
+# if the compiler knows the switch, use it, otherwise try to work without it
+SET(CXX11_TESTSRC "struct z{int a=3;}; int main(){int a[3];for(auto x:a) return x;}")
+
+# if the compiler knows the switch, use it, otherwise try to work without it
+SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} -std=c++11 ")
+CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" SET_CXX11_FLAGS)
+if(SET_CXX11_FLAGS)
+   SET(FLAGS_MIN ${CMAKE_REQUIRED_FLAGS})
+
+# also look for a very specific cygwin bug
+SET(GNU11_BUGSRC "
+#include <cstdio>
+int main() { char buf[20]; return snprintf(buf,3,0); }
+")
+CHECK_CXX_SOURCE_COMPILES("${GNU11_BUGSRC}" HAS_NOGNU11BUG)
+if(NOT HAS_NOGNU11BUG)
+message("- WARNING: this compiler seems to have an old bug with missing definitions, trying to workaround. See http://cygwin.com/ml/cygwin/2012-04/msg00140.html for details.")
+   SET(FLAGS_MIN " ${CMAKE_REQUIRED_FLAGS} -std=gnu++11 " )
+endif(NOT HAS_NOGNU11BUG)
+
+
+else(SET_CXX11_FLAGS)
+   SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
+   CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" CXX11_IS_DEFAULT)
+   IF(NOT CXX11_IS_DEFAULT)
+      message(FATAL_ERROR "- Error: failed to configure compiler for C++11 support. For GCC, version 4.7 or newer is required.")
+   ENDIF(NOT CXX11_IS_DEFAULT)
+endif(SET_CXX11_FLAGS)
+
+endif(USE_CXX11)
+
+#if(NOT ADDDEBUGSRC)
+#SET(CMAKE_REQUIRED_FLAGS "${FLAGS_MIN} -flto")
+#SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN} -flto ")
+#CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" USE_LTO)
+#if(USE_LTO)
+#   SET(FLAGS_MIN ${CMAKE_REQUIRED_FLAGS})
+#   SET(LDFLAGS_MIN ${CMAKE_EXE_LINKER_FLAGS})
+#else(USE_LTO)
+#   SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}")
+#endif(USE_LTO)
+#endif(NOT ADDDEBUGSRC)
+
+
+SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
+SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}  -Wl,--as-needed ")
+CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" USE_WLASNEEDED)
+if(USE_WLASNEEDED)
+   SET(LDFLAGS_MIN ${CMAKE_EXE_LINKER_FLAGS})
+else(USE_WLASNEEDED)
+   SET(CMAKE_EXE_LINKER_FLAGS "${LDFLAGS_MIN}")
+endif(USE_WLASNEEDED)
 
 #INCLUDE(FindZLIB) # broken, hangs for 10 seconds
 # header check should be enough, gzip should be everywhere nowadays
 #CHECK_INCLUDE_FILES("gzip.h" HAVE_ZLIB)
 FIND_PATH(HAVE_ZLIB zlib.h )
-if(NOT HAVE_ZLIB)
-   message(FATAL_ERROR "apt-cacher-ng requires gzip library and development files ${HAVE_ZLIB}")
-endif(NOT HAVE_ZLIB)
+if(HAVE_ZLIB)
+	list(APPEND AcngLdList z)
+	INCLUDE_DIRECTORIES(${HAVE_ZLIB})
+else(HAVE_ZLIB)
+   message(FATAL_ERROR "- apt-cacher-ng requires gzip library and development files ${HAVE_ZLIB}")
+endif(HAVE_ZLIB)
 
 INCLUDE(FindBZip2)
 if (BZIP2_FOUND)
    SET(HAVE_LIBBZ2 1)
    MARK_AS_ADVANCED(HAVE_LIBBZ2)
+	INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
+	list(APPEND AcngLdList bz2)
 else (BZIP2_FOUND)
-   message(FATAL_ERROR "apt-cacher-ng requires bzip2 library and development files")
+   message("- apt-cacher-ng requires bzip2 library and development files for bz2 format support")
 endif (BZIP2_FOUND)
 
-INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
-
-SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} -Wl,--as-needed")
-SET(TESTSRC "int main() {return 0;}")
-CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WL_AS_NEEDED)
-
-# this flags are set to common base for the rest of the tests
-SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} ")
-
-
+SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
 SET(CMAKE_REQUIRED_LIBRARIES lzma)
 SET(TESTSRC "
 #include <lzma.h>
@@ -71,7 +120,7 @@
 IF(HAVE_LZMA)
    list(APPEND AcngLdList lzma)
 ELSE(HAVE_LZMA)
-   MESSAGE("XZ (liblzma) not found or not working, disabling support")
+   MESSAGE("- XZ (liblzma) not found or not working, disabling support")
    SET(HAVE_LZMA )
 ENDIF(HAVE_LZMA)
 SET(CMAKE_REQUIRED_LIBRARIES "")
@@ -83,7 +132,7 @@
 IF(HAVE_SSL)
    list(APPEND AcngLdList "${SSL_LIB_LIST}")
 ELSE(HAVE_SSL)
-   MESSAGE("OpenSSL not found or not working, disabling support")
+   MESSAGE("- OpenSSL not found or not working, disabling support")
    SET(HAVE_SSL )
    SET(SSL_LIB_LIST )
 ENDIF(HAVE_SSL)
@@ -98,17 +147,21 @@
 IF(HAVE_LIBWRAP)
    list(APPEND AcngLdList wrap)
 ELSE(HAVE_LIBWRAP)
-   MESSAGE("libwrap development files not usable, disabling support")
+   MESSAGE("- libwrap development files not usable, disabling support")
    SET(HAVE_LIBWRAP)
 ENDIF(HAVE_LIBWRAP)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
-
+if(CYGWIN)
+message("- Not using wordexp on Cygwin, not reliable")
+set(HAVE_WORDEXP FALSE)
+else()
 SET(TESTSRC "
 #include <wordexp.h>
 int main(int argc, char **argv) { wordexp_t p; return wordexp(*argv, &p, 0); }
 ")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_WORDEXP)
+endif()
 
 SET(TESTSRC "
 #include <glob.h>
@@ -222,12 +275,21 @@
 
 SET(CMAKE_REQUIRED_LIBRARIES dl)
 CHECK_CXX_SOURCE_COMPILES("#include \"${CMAKE_SOURCE_DIR}/include/testdlopen.h\"" HAVE_DLOPEN)
-SET(CMAKE_REQUIRED_LIBRARIES "")
 
 # maybe enable workaround for platforms with a weird implementation
 SET(CMAKE_REQUIRED_LIBRARIES pthread)
 CHECK_CXX_SOURCE_RUNS("#include \"${CMAKE_SOURCE_DIR}/include/testpthread.h\"" PTHREAD_COND_TIMEDWAIT_TIME_RANGE_OK)
+
+
+##################################
+# All checks done, start building
+
 SET(CMAKE_REQUIRED_LIBRARIES "")
+SET(CMAKE_REQUIRED_FLAGS ${FLAGS_MIN})
+
+# I don't need -rdynamic, thanks!
+SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
+SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
 
 
 FILE(GLOB SRCS "${CMAKE_SOURCE_DIR}/source/*.cc")
@@ -237,12 +299,10 @@
 
 SET_TARGET_PROPERTIES(apt-cacher-ng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})
 
-
 ADD_EXECUTABLE(in.acng client/client.cc)
 SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS ${FLAGS_MIN})
 
-IF(HAVE_WL_AS_NEEDED)
-SET_TARGET_PROPERTIES(in.acng apt-cacher-ng PROPERTIES LINK_FLAGS  -Wl,--as-needed)
+#IF(HAVE_WL_AS_NEEDED)
 # funny hack, link with gcc and avoid libstdc++/libm (since no STL parts used
 # there). However, it needs to be investigated - the alternative linking makes
 # the binary 40kb larger, might include higher relocation costs and bigger
@@ -250,7 +310,7 @@
 # server process.
 #TARGET_LINK_LIBRARIES(in.acng supc++)
 #SET_TARGET_PROPERTIES(in.acng PROPERTIES LINKER_LANGUAGE C)
-ENDIF(HAVE_WL_AS_NEEDED)
+#ENDIF(HAVE_WL_AS_NEEDED)
 
 
 ############################################
@@ -274,7 +334,7 @@
 #include <fuse.h>
 int main() { return 0; }
 ")
-SET(CMAKE_REQUIRED_FLAGS ${fuse_cflags})
+SET(CMAKE_REQUIRED_FLAGS " ${FLAGS_MIN} ${fuse_cflags}")
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_FUSE_25)
 
 if(fuse_FOUND AND HAVE_FUSE_25)
@@ -292,18 +352,8 @@
       TARGET_LINK_LIBRARIES(acngfs ${fuse_LDFLAGS} ${SSL_LIB_LIST})
    endif(HAVE_DLOPEN)
 
-   IF(HAVE_WL_AS_NEEDED)
-      SET_TARGET_PROPERTIES(acngfs PROPERTIES LINK_FLAGS  -Wl,--as-needed)
-   ENDIF(HAVE_WL_AS_NEEDED)
-
-
 else(fuse_FOUND AND HAVE_FUSE_25)
-   message("FUSE not found or incompatible, not building acngfs")
+   message("- FUSE not found or not compatible, not building acngfs")
 endif(fuse_FOUND AND HAVE_FUSE_25)
 
 
-#######################################
-# all checks done, save configuration #
-#######################################
-
-CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")

=== dbgen/Makefile ===

DBTMP=tmp
CONFDIR=conf

# Main rule to be called to update all databases. Does two things, first get
# and pre-filter raw data, second: check the sources and generate final lists,
# skipping dead mirrors.
gendbs: $(CONFDIR) clean_db_tmp get_deb_input get_ubu_input get_fedora_input get_sl_input
	$(MAKE) $(CONFDIR)/deb_mirrors.gz $(CONFDIR)/debvol_mirrors.gz $(CONFDIR)/gentoo_mirrors.gz
	$(MAKE) $(CONFDIR)/ubuntu_mirrors $(CONFDIR)/cygwin_mirrors $(CONFDIR)/archlx_mirrors $(CONFDIR)/fedora_mirrors $(CONFDIR)/epel_mirrors $(CONFDIR)/sl_mirrors

clean_db_tmp:
	rm -rf "$(DBTMP)"

$(CONFDIR):
	mkdir -p $(CONFDIR)

$(DBTMP):
	mkdir -p $(DBTMP)

# the get_* targets are intended to fetch data, but only change the key file (prerequisite for other rules) if the data has really changed
# this is the first stage of the gendbs target. 
get_deb_input: $(DBTMP)
# they block checkout mode for some reason but we don't care
#	wget -q -O $(DBTMP)/dsnap 'http://anonscm.debian.org/viewvc/webwml/webwml/english/mirror/Mirrors.masterlist?view=co'
	wget -q -O- 'http://anonscm.debian.org/viewvc/webwml/webwml/english/mirror/Mirrors.masterlist?view=markup' | grep file.line.text | sed -e 's,.*>,,' > $(DBTMP)/dsnap
	md5sum $(DBTMP)/dsnap > $(DBTMP)/sig-debian
	cmp sig-debian $(DBTMP)/sig-debian 2>/dev/null || cp $(DBTMP)/sig-debian sig-debian

# some country-TLDed mirrors are not listed in the mirror list, adding them manually
get_ubu_input:
	( w3m -dump http://www.iana.org/domains/root/db | perl -pe 'if(/^\.(\w\w)\s/) { $$_="http://".lc($$1).".archive.ubuntu.com/ubuntu\n";} else {undef $$_}';  wget -q -O- 'https://wiki.ubuntu.com/Mirrors?action=show&redirect=Archive' 'https://launchpad.net/ubuntu/+archivemirrors' ) | tr -d ' ' | tr -d '\t' | sed -e 's,",\n,g' | grep ^http | sort -u > $(DBTMP)/usnap
	md5sum $(DBTMP)/usnap > $(DBTMP)/sig-ubuntu
	cmp sig-ubuntu $(DBTMP)/sig-ubuntu 2>/dev/null || cp $(DBTMP)/sig-ubuntu sig-ubuntu 

get_fedora_input:
	wget -O- https://mirrors.fedoraproject.org/publiclist/ | tr '"' '\n' | grep -iE '^http.*(linux|epel)/?$$' | sort -u > $(DBTMP)/fsnap
	md5sum $(DBTMP)/fsnap > $(DBTMP)/sig-fsnap
	cmp sig-fsnap $(DBTMP)/sig-fsnap 2>/dev/null || cp $(DBTMP)/sig-fsnap sig-fsnap

get_sl_input:
	wget -O- http://www.scientificlinux.org/download/mirrors | tr '"' '\n' | grep -iE '^http.*(scientific|linux|scientific-linux)/?$$' |sort -u > $(DBTMP)/slsnap
	# the mirrors list for SL does not contain the three main sites; so adding these manually
	printf "http://ftp.scientificlinux.org/linux/scientific/\nhttp://ftp1.scientificlinux.org/linux/scientific/\nhttp://ftp2.scientificlinux.org/linux/scientific/\n" >> $(DBTMP)/slsnap
	md5sum $(DBTMP)/slsnap > $(DBTMP)/sig-slsnap
	cmp sig-slsnap $(DBTMP)/sig-slsnap 2>/dev/null || cp $(DBTMP)/sig-slsnap sig-slsnap

# the $(CONFDIR)/* targets are intended to check the raw data got in the first step and 
# generate the final lists, skipping dead mirrors. this is the second stage of the gendbs target. 
$(CONFDIR)/epel_mirrors: sig-fsnap ubuntuscan.sh
	grep -iE 'epel/?$$' $(DBTMP)/fsnap | sort -u > $(DBTMP)/epelsnap
	bash ubuntuscan.sh $@ $(DBTMP)/epelsnap $(DBTMP) "/" "RPM-GPG-KEY-EPEL"

$(CONFDIR)/fedora_mirrors: sig-fsnap ubuntuscan.sh
	grep -iE 'linux/?$$' $(DBTMP)/fsnap | sort -u > $(DBTMP)/fcsnap
	bash ubuntuscan.sh $@ $(DBTMP)/fcsnap $(DBTMP) "/" "releases"

$(CONFDIR)/sl_mirrors: sig-slsnap ubuntuscan.sh
	bash ubuntuscan.sh $@ $(DBTMP)/slsnap $(DBTMP) "/" "5rolling\|6rolling"

$(CONFDIR)/ubuntu_mirrors: sig-ubuntu ubuntuscan.sh
	bash ubuntuscan.sh $@ $(DBTMP)/usnap $(DBTMP) "/pool/" "main"

$(CONFDIR)/cygwin_mirrors: sig-cygwin
	wget -q -O- http://cygwin.com/mirrors.lst | grep ^http | cut -f1 -d\; | sort -u > $(CONFDIR)/cygwin_mirrors

$(CONFDIR)/archlx_mirrors:
	wget -q --no-check-certificate  -O- 'https://archlinux.de/?page=MirrorStatus' | grep nofollow | cut -f2 -d'"'  | grep ^http | sort -u > $(CONFDIR)/archlx_mirrors

$(CONFDIR)/deb_mirrors.gz: sig-debian deburlgen.pl
	perl deburlgen.pl Archive-http < $(DBTMP)/dsnap > $(DBTMP)/dsnap.urls
	echo http://ftp.debian.org/debian/ >> $(DBTMP)/dsnap.urls
	echo http://ftp.debian.com/debian/ >> $(DBTMP)/dsnap.urls
	echo http://cdn.debian.net/debian/ >> $(DBTMP)/dsnap.urls
	echo http://http.debian.net/debian/ >> $(DBTMP)/dsnap.urls
# a way too experimental...	echo http://http.debian.net/debian/ >> $(DBTMP)/dsnap.urls
# there is no pool... echo http://ftp-master.debian.org/newdists/ >> $(DBTMP)/dsnap.urls
	bash ubuntuscan.sh $(CONFDIR)/deb_mirrors $(DBTMP)/dsnap.urls $(DBTMP) "/dists"
	gzip -f -9 $(CONFDIR)/deb_mirrors

$(CONFDIR)/debvol_mirrors.gz: sig-debian deburlgen.pl
	perl deburlgen.pl Volatile-http < $(DBTMP)/dsnap > $(DBTMP)/debvol.urls
	bash ubuntuscan.sh $(CONFDIR)/debvol_mirrors $(DBTMP)/debvol.urls $(DBTMP) "/dists"
	gzip -f -9 $(CONFDIR)/debvol_mirrors

$(CONFDIR)/gentoo_mirrors.gz:
	cd conf && sh ../gentoo_mirrors.sh

package:
	tar c $(DBTMP)/sig-* sig-* deburlgen.pl gentoo_mirrors.sh ubuntuscan.sh | gzip -9 > $(DBGENERATOR).tgz

=== debian/changelog ===
apt-cacher-ng (0.7.27-1~bpo70+1) wheezy-backports; urgency=low

  * Update of the Wheezy backport

 -- Eduard Bloch <blade@debian.org>  Sun, 24 Aug 2014 16:38:41 -0700

apt-cacher-ng (0.7.27-1) unstable; urgency=medium

  * New upstream release
    + Includes fix of CVE-2014-4510, package patch dropped
  * Moved avahi-daemon to Suggests (LP: #1259191)

 -- Eduard Bloch <blade@debian.org>  Thu, 17 Jul 2014 21:10:25 +0200

apt-cacher-ng (0.7.26-2~bpo70+1) unstable; urgency=low

  * Wheezy backport, changes only from 0.7.25-1~bpo70+1

 -- Eduard Bloch <blade@debian.org>  Sat, 28 Jun 2014 13:54:12 +0200

apt-cacher-ng (0.7.26-2) unstable; urgency=high

  * Do not print the submitted (raw) file path in the response body of a 403
    message (CVE-2014-4510)

 -- Eduard Bloch <blade@debian.org>  Tue, 24 Jun 2014 19:19:29 +0200

apt-cacher-ng (0.7.25~bpo70+1) wheezy-backports; urgency=low

  * Updated wheezy backport

 -- Eduard Bloch <blade@debian.org>  Mon, 03 Feb 2014 22:11:29 +0100

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,9 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
 Pre-Depends: dpkg (>= 1.15.6)
-Recommends: ed, avahi-daemon
+Recommends: ed
 Conflicts: logrotate (<< 3.8.0)
-Suggests: doc-base, libfuse2 (>= 2.5), curl | wget
+Suggests: doc-base, libfuse2 (>= 2.5), curl | wget, avahi-daemon
 Description: caching proxy server for software repositories
  Apt-Cacher NG is a caching proxy for downloading packages from Debian-style
  software repositories (or possibly from other types).

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 CDIR=$(TGT)/etc/apt-cacher-ng
 
 %:
-	dh $@ --parallel --with systemd
+	dh $@ --parallel
 
 override_dh_install:
 	dh_install $(test -e build/acngfs || echo -Xacngfs)
